/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ca.mcscert.jtet.expression;

/**
 *
 * @author matthew
 */
public final class Literal implements Expression, ExpressionValue {

    public Literal(String value) {
        m_value = value;
    }

    @Override
    public Type actualOutputTypeForRequestedOutput(TypeMarker requestedType) {
        if (requestedType instanceof RealType ||
                requestedType instanceof FixedPointType) {
            return (Type)requestedType;
        }
        return null;
    }

    @Override
    public String getCheckerOutput(ExpressionGenerator generator, Type requestedType) {
        return generator.GenerateLiteralValue(m_value, requestedType);
    }

    @Override
    public String toString() {
        return m_value;
    }

    final String m_value;
}
